local BuffedSorter = {} 
local ConfigShown 
local ActiveButton -- the button that has been clicked to bring up the menu, needs replacing with self.value in the dropdown intilialisation
BuffedProfiles = {FilterFrames = { BuffedBuffButton = {}, BuffedDebuffButton = {}, TargetBuffedButton = {}, TargetDebuffedButton = {}, },}

local FrameColours = {TargetBuff = {r = 0, g = 0.4, b = 0}, 
							Buff = {r = 0, g = 1, b = 0}, 
							Debuff = {r = 1, g = 0, b = 0},
							Wep = {r = 1, g = 0, b = 1}, 
							TargetDebuff =	{r = 0.4, g = 0, b = 0}, 
							Master = {r = 1, g = 1, b = 1}, 
							Filter = {r = 0, g = 0, b = 1}, }
							
local LoadOrder = { "Buff", "Debuff","TargetBuff", "TargetDebuff", "Wep", "Master", "Filter", } 
							
local function BuffedOnDragStart(self, index, button) -- start dragging config frames
	local BuffButton = _G[self..index]
	if (button == "LeftButton") then 
		BuffButton:StartMoving()
	elseif (button == "RightButton") then 
		ActiveButton = BuffButton
		ToggleDropDownMenu(1, nil, _G["BuffedBuffConfig"], BuffButton, 30, 20)
	end
end

local function ToggleLock(msg) -- show/hide config frames and hide the extra frames if the number has changed
	if not ConfigShown then 
		for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
			for i = 1, FrameNum do 
				local f = _G["Buffed"..FrameName..i]
				if f and f.enabled then --if the frame exists and is enabled, show it!
					f:Show()
				end
			end
		end
		ConfigShown = 1
	else
		for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
			for i = 1, 32 do --this ensures all excess frames aree hidden
				local f = _G["Buffed"..FrameName..i]
				if f then 
					f:Hide()
				end
			end
		end
		ConfigShown = nil
	end
end

local function BuffedOnDragStop(self, index) -- stop dragging config frames and set positions
	local BuffButton = _G[self..index]
	BuffButton:StopMovingOrSizing()
	for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do	
		for i = 1, FrameNum do
		local BBleft, BBright, BBtop, BuffBottom = BuffButton:GetLeft(),  BuffButton:GetRight(),  BuffButton:GetTop(),  BuffButton:GetBottom()
		local BBpoint, BBrelativeTo, BBrelativePoint, BBxofs, BByofs = BuffButton:GetPoint()	
			if not ( i == index ) then
				local frame = _G["Buffed"..FrameName..i]
				local point, relativeTo, relativePoint, xofs, yofs = frame:GetPoint()
				local height, width = frame:GetHeight(), frame:GetWidth()
				if ( BByofs > (yofs - 150) ) and ( BByofs < (yofs + 150)) and ( BBxofs > (xofs - 150) ) and ( BBxofs < (xofs + 150)) then
					if ( BBxofs > (xofs - 10) ) and ( BBxofs < (xofs + 10))   then
						if BuffButton.StickyPos then
							BuffButton:ClearAllPoints()
							BuffButton:SetPoint(BBpoint, BBrelativeTo, BBrelativePoint, xofs, BByofs)
						end
						if BuffButton.StickySize then
							BuffButton:SetWidth(width)
							BuffButton:SetHeight(height)
						end
					end
					if ( BByofs > (yofs - 10) ) and ( BByofs < (yofs + 10) ) then
						if BuffButton.StickyPos then
							BuffButton:ClearAllPoints()
							BuffButton:SetPoint(BBpoint, BBrelativeTo, BBrelativePoint, BBxofs, yofs)
						end
						if BuffButton.StickySize then
							BuffButton:SetWidth(width)
							BuffButton:SetHeight(height)
						end
					end	
				end
			end
		end
	end
	--[[if not BuffedProfiles[UnitName("player")] then
		BuffedProfiles[UnitName("player")] = {combat = {}, nocombat = {}}
	end
	local width, height = floor(BuffButton:GetWidth() + 0.5), floor(BuffButton:GetHeight() + 0.5)
	BuffedProfiles[UnitName("player")].nocombat[BuffButton:GetName()] = {width = width, height = height, point = BBpoint, relativePoint = BBrelativePoint, xofs = floor(BBxofs*100+0.5)/100, yofs = floor(BByofs*100+0.5)/100}
	]]
	BuffedUpdate()
end

local function CreateConfigFrames() -- first creation of config frames
local count = 40
	for j = 1, #LoadOrder do
	local FrameName = LoadOrder[j]
	local FrameNum = BuffedSettings.FrameCreation[LoadOrder[j]]
	--print(LoadOrder[j])
		for i = 1, FrameNum do 
		count = count + 1
			if not _G["Buffed"..FrameName..i] then
				local f = CreateFrame("Button", "Buffed"..FrameName..i, UIParent, "AuraButtonTemplate")
				f:SetMovable(true)
				f.corner = CreateFrame("Button", "Buffed"..FrameName.."Corner"..i, f, f)
				f.corner:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT")
				f.corner:SetPoint("TOPLEFT", f, "CENTER", 5, -5)
				f.corner:SetMovable(true)
				f.cornerT = f.corner:CreateTexture()
				f.cornerT:SetTexture("Interface\\AddOns\\Buffed!\\ResizerButton.tga")
				f.cornerT:SetAllPoints(f.corner)
				f.corner:Hide()
				f.StickyPos = 1
				f.StickySize = 1
				f.resizing = nil
				f.verbose = true
				f.alpha = false
				f.enabled = true
				f:SetResizable(true)
				f:SetFrameStrata("HIGH")
				f:SetMaxResize(80,80)
				f:SetMinResize(15,15)
				f.corner:SetResizable(true)
				local duration = _G["Buffed"..FrameName..i.."Duration"]
				duration:SetText("0:00")
				duration:SetVertexColor(1,1,1)
				duration:Show()
				f:EnableMouse(true)
				f.corner:EnableMouse(true)
				f:SetScript("OnMouseDown", function(self, button) BuffedOnDragStart("Buffed"..FrameName, i, button); end)
				f:SetScript("OnMouseUp", function()  BuffedOnDragStop("Buffed"..FrameName, i) end)
				f.corner:SetScript("OnMouseDown", function()  f:StartSizing(); f.resizing = true; end)
				f.corner:SetScript("OnUpdate", function() if f.resizing then f:SetWidth(math.max(f:GetWidth(), f:GetHeight())); f:SetHeight(math.max(f:GetWidth(), f:GetHeight())) end end)
				f.corner:SetScript("OnMouseUp", function() --if its the master frame, set all other frames the same size
												f.resizing = nil
												f:StopMovingOrSizing()
												BuffedUpdate()
													if (FrameName == "Master" ) then
														for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
															for i = 1, FrameNum do
																local fr = _G["Buffed"..FrameName..i]
																fr:SetWidth(f:GetWidth())
																fr:SetHeight(f:GetHeight())
															end 
														end 
													end 
												end)
				f.fs = f:CreateFontString( FrameName.."FS"..i, "OVERLAY", "GameFontNormal")
				
				f.fs:SetText(i)
					if (FrameName == "Master" )then -- make the master frame larger, change its label
						f:SetWidth(40)
						f:SetHeight(40)
						f.fs:SetWidth(20)
						f.fs:SetText("M")	
					end
				f.fs:SetPoint("CENTER")
				
				local x = cos((360/25)*count)*4*count
				local y = sin((360/25)*count)*4*count
				f:SetPoint("CENTER", UIParent, "CENTER", x , y)
				f.t = f:CreateTexture()
				f.t:SetTexture("Interface\\AddOns\\Buffed!\\ConfTexture.tga")
				f.t:SetAllPoints(f)
				f.t:SetVertexColor(FrameColours[FrameName].r,FrameColours[FrameName].g,FrameColours[FrameName].b)
				f:Hide()
				if (FrameName == "Filter" )then
					f.enabled = false
					f.fs:SetPoint("BOTTOM", f, "TOP", 10, 0)
					f.fs:SetWidth(80)
				end
			end
		end
	end
end
	
local function CreateSettingsMenu()
local ConFrame = CreateFrame("Frame")
local ConfigLayout = {  
	BuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedBuffSlider", Location = "CENTER", Xoff = 0,Yoff = 150, Parent = ConFrame,
		Min = 0, Max = 32, Step = 1, StartVal = BuffedSettings.FrameCreation.Buff,LowText = 0, HighText = 32,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedSettings.FrameCreation.Buff = self:GetValue(); _G["BuffString"]:SetText(self:GetValue()) end,},
		Script2 = {event = "OnMouseUp", func = function()  CreateConfigFrames(); ToggleLock("config"); ToggleLock("config"); end,}
				},
	DebuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedDebuffSlider", Location = "CENTER", Xoff = 0, Yoff = 100, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedSettings.FrameCreation.Debuff, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedSettings.FrameCreation.Debuff = self:GetValue(); _G["DebuffString"]:SetText(self:GetValue()) end,},
		Script2 = {event = "OnMouseUp", func = function() CreateConfigFrames(); ToggleLock("config"); ToggleLock("config"); end,}
				},
	TargetBuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedTargetBuffSlider", Location = "CENTER", Xoff = 0, Yoff = 50, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedSettings.FrameCreation.TargetBuff, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedSettings.FrameCreation.TargetBuff = self:GetValue(); _G["TargBuffString"]:SetText(self:GetValue())end,},
		Script2 = {event = "OnMouseUp", func = function() CreateConfigFrames(); ToggleLock("config"); ToggleLock("config"); end,}
				},
	TargetDebuffSlider = { Ftype = "Slider", Inherits = "OptionsSliderTemplate",
		FName = "BuffedTargetDebuffSlider", Location = "CENTER", Xoff = 0, Yoff = 0, Parent = ConFrame,
		Min = 0, Max = 16, Step = 1, StartVal = BuffedSettings.FrameCreation.TargetDebuff, LowText = 1, HighText = 16,
		Script1 = {event = "OnValueChanged", func = function(self) BuffedSettings.FrameCreation.TargetDebuff = self:GetValue(); _G["TargDebuffString"]:SetText(self:GetValue())end,},
		Script2 = {event = "OnMouseUp", func = function() CreateConfigFrames(); ToggleLock("config"); ToggleLock("config"); end,}
				},
	BuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 150, Parent = ConFrame["BuffSlider"],
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	DebuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 100, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TargBuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 50, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TargDebuffString = { Ftype = "FontString", Location = "CENTER", Xoff = 110, Yoff = 0, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 60, Height = 15,	
				},
	TitleString = { Ftype = "FontString", Location = "CENTER", Xoff = 0, Yoff = 200, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Buffed! Options",
				},
	BuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 150, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Buff Count:",
				},
	DebuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 100, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Debuff Count:",
				},
	TargetBuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 50, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Target buff:",
				},
	TargetDebuffLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = 0, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 150, Height = 15, StringVal = "Target debuff:",
				},
	WepEnchLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = -50, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 200, Height = 15, StringVal = "Show Weapon Enchants:",
				},	
	DurationLabel = { Ftype = "FontString", Location = "CENTER", Xoff = -120, Yoff = -100, Parent = ConFrame,
					R = 1, G = 1, B = 1, Width = 200, Height = 15, StringVal = "Sort By Duration",
				},	
	WepEnchToggle = { Ftype = "CheckButton", Inherits = "InterfaceOptionsCheckButtonTemplate",
				FName = "BuffedTargetDebuffSlider", Location = "CENTER", Xoff = 0, Yoff = -50, Parent = ConFrame,
				Script1 = {event = "OnMouseUp", func = function(self)  if TemporaryEnchantFrame:IsShown() then BuffedSettings.FrameCreation.Wep = 0; TemporaryEnchantFrame:Hide()	else BuffedSettings.FrameCreation.Wep = 2; TemporaryEnchantFrame:Show();BuffedUpdate(); end; 
						ToggleLock("config"); ToggleLock("config"); 
					end, variable = TemporaryEnchantFrame:IsShown()},
				},
	BuffSortToggle = { Ftype = "CheckButton", Inherits = "InterfaceOptionsCheckButtonTemplate",
				FName = "BuffedDurationButton", Location = "CENTER", Xoff = 0, Yoff = -100, Parent = ConFrame,
				Script1 = {event = "OnMouseUp", func = function(self)  if BuffedSettings.duration then BuffedSettings.duration = false; BuffedUpdate(); else BuffedSettings.duration = true; BuffedUpdate(); end; 
						ToggleLock("config"); ToggleLock("config"); 
					end, variable = BuffedSettings.duration},
				},
		}

local Text = {}
for Name, values in pairs(ConfigLayout) do 

	if ( values.Ftype == "Frame" ) or ( values.Ftype == "Slider" ) or  ( values.Ftype == "CheckButton" ) then
		ConFrame[Name] = CreateFrame(values.Ftype, values.FName, values.Parent, values.Inherits)
		if ( values.Ftype == "Slider" ) then
			ConFrame[Name]:SetMinMaxValues(values.Min,values.Max)
			ConFrame[Name]:SetValueStep(values.Step)
			ConFrame[Name]:SetValue(values.StartVal)
			_G[values.FName.."Low"]:SetText(values.LowText)
			_G[values.FName.."High"]:SetText(values.HighText)
		end
		if (values.Ftype == "CheckButton") then
			if values.variable then
				ConFrame[Name]:SetChecked(true)
			else
				ConFrame[Name]:SetChecked(false)
			end
		end
		if values["Script1"] then
				ConFrame[Name]:SetScript(values["Script1"].event, values["Script1"].func)
		end
			ConFrame[Name]:SetScript(values["Script1"].event, values["Script1"].func)
		if values["Script2"] then
			ConFrame[Name]:SetScript(values["Script2"].event, values["Script2"].func)
		end
		
	end
	if ( values.Ftype == "FontString" ) then
		ConFrame[Name] = ConFrame:CreateFontString(Name, "OVERLAY", "GameFontNormal")
		ConFrame[Name]:SetWidth(values.Width)
		ConFrame[Name]:SetHeight(values.Height)
		ConFrame[Name]:SetTextColor(values.R,values.G,values.B)
		if values.StringVal then
			ConFrame[Name]:SetText(values.StringVal)
		end
	end
ConFrame[Name]:SetPoint(values.Location,values.Xoff,values.Yoff)

end

ConFrame.name = "Buffed!"
InterfaceOptions_AddCategory(ConFrame)

end


local function BuffedOnLoad(self, event, ...)

	if event == "ADDON_LOADED" then
		if select(1, ...) == "Buffed!" then
			if not BuffedSettings then
				BuffedSettings = {}
				BuffedSettings.FrameCreation = {TargetBuff = 7, Buff = 7, Debuff = 7, Wep = 2, TargetDebuff = 7, Master = 1, Filter = 20,}
				BuffedSettings.duration = false
				BuffedSettings.animation = false
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
			for i = 1, 32 do 
				local f = _G["Buffed"..FrameName..i]
				if f then
					if BuffedProfiles[UnitName("player")] and BuffedProfiles[UnitName("player")].nocombat and BuffedProfiles[UnitName("player")].nocombat["Buffed"..FrameName..i] then
						local pos = BuffedProfiles[UnitName("player")].nocombat["Buffed"..FrameName..i]
						f:SetPoint(pos.point, UIParent, pos.relativePoint, pos.xofs, pos.yofs)
						f:SetWidth(pos.width)
						f:SetHeight(pos.height)
						--print( pos.relativePoint, pos.xofs, pos.yofs)
					end
				end
			end
		end
		CreateConfigFrames()
			CreateSettingsMenu()
			BuffedUpdate()
		if (BuffedSettings.FrameCreation.Wep == 0) then
			TemporaryEnchantFrame:Hide()
		end
		for i = 1, BuffedSettings.FrameCreation.Filter do 
			if _G["BuffedFilter"..i] then
				for Name, Filter in pairs(BuffedProfiles.FilterFrames) do
					if Filter["BuffedFilter"..i] then
						local frame = _G["BuffedFilter"..i]
						local g = Filter["BuffedFilter"..i]
								frame.enabled = g.enabled
								frame.name = g.name
								frame.Ftype = g.Ftype
								frame.fs:SetText(g.text)
					end
				end
			end
		end
	end
end

local moop = CreateFrame("Frame")
moop:RegisterEvent("ADDON_LOADED")
moop:RegisterEvent("PLAYER_ENTERING_WORLD")
moop:SetScript("OnEvent", BuffedOnLoad)

local DropDownTest = CreateFrame("Frame", "BuffedBuffConfig", UIParent, "UIDropDownMenuTemplate")
DropDownTest:SetPoint("CENTER")
UIDropDownMenu_SetWidth(DropDownTest, 65)
UIDropDownMenu_SetButtonWidth(DropDownTest, 20)
DropDownTest:Hide()
local function DropDownTest_ItemClick()
	UIDropDownMenu_SetSelectedValue(this.owner, this.value);
end

local function DropDownTest_Initialize() -- the menu items, needs a cleanup
	level = level or 1
	local info = UIDropDownMenu_CreateInfo()
	if ActiveButton then
			info.text = "Sticky Positioning"
			info.value = 1
			info.checked = ActiveButton.StickyPos
			info.tooltipTitle = "Sticky Positioning"
			info.tooltipText = "Aligns the buffs with other nearby buffs"
			if (ActiveButton:GetName() == "BuffedMaster1") then
				info.func = function() 
					if ActiveButton.StickyPos then 
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]; 
								f.StickyPos = nil 
							end
						end
					else
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]; 
								f.StickyPos = 1
							end
						end
					end
				end
			else
				info.func = function() if ActiveButton.StickyPos then ActiveButton.StickyPos = nil else ActiveButton.StickyPos = 1 end end
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sticky Sizing"
			info.value = 2
			info.checked = ActiveButton.StickySize
			info.tooltipTitle = "Sticky Sizing"
			info.tooltipText = "Sets the size of the buff to other nearby buffs"
			if (ActiveButton:GetName() == "BuffedMaster1") then
				info.func = function() 
					if ActiveButton.StickySize then 
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]
								if f then
									f.StickySize = nil
								end
							end
						end
					else
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]
								if f then
									f.StickySize = 1
								end
							end
						end
					end
				end
			else
				info.func = function() if ActiveButton.StickySize then ActiveButton.StickySize = nil else ActiveButton.StickySize = 1 end end
			end
			
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Sticky Padding"
			info.value = 3
			info.checked =  nil
			info.tooltipTitle = "Sticky Padding"
			info.tooltipText = "Attempts to even out the padding between nearby buffs"
			info.func = function()  end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Resizable"
			info.value = 4
			info.checked = ActiveButton.corner:IsShown()
			info.tooltipTitle = "Resizable"
			info.tooltipText = "Shows a draggable icon to allow buff resizing"
			if (ActiveButton:GetName() == "BuffedMaster1") then
				info.func = function() 
					if ActiveButton.corner:IsShown() then 
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]
								if f then
									f.corner:Hide()
								end
							end
						end
					else
						for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
							for i = 1, FrameNum do 
								local f = _G["Buffed"..FrameName..i]
								if f then
									f.corner:Show()
								end
							end
						end
					end
				end
			else
				info.func = function() if ActiveButton.corner:IsShown() then ActiveButton.corner:Hide() else ActiveButton.corner:Show()  end end
			end
			UIDropDownMenu_AddButton(info, level)
			
			info.text = "Reset Size"
			info.value = 5
			info.checked = nil
			info.tooltipTitle = "Reset Size"
			info.tooltipText = "Resets the size of the buff to default values"
			if (ActiveButton:GetName() == "BuffedMaster1") then
				info.func = function() 
					for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
						for i = 1, FrameNum do 
							local f = _G["Buffed"..FrameName..i]
							if f then
								f:SetWidth(30) 
								f:SetHeight(30)
							end
						end
					end	
				end
			else
				info.func = function() ActiveButton:SetWidth(30) ActiveButton:SetHeight(30)  end
			end
			UIDropDownMenu_AddButton(info, level)
			
			for i = 1, 16 do
				if (ActiveButton:GetName() == "BuffedFilter"..i) then
					info.text = "Delete Filter"
					info.value = 3
					info.checked =  nil
					info.tooltipTitle = "Delete Filter"
					info.tooltipText = "Deletes the filter, sending the buff back to the default stack"
					info.func = function()  
					ActiveButton.enabled = false
					BuffedProfiles.FilterFrames[ActiveButton.Ftype][ActiveButton.name] = nil
					ActiveButton.name = nil
					ToggleLock()
					ToggleLock()
					BuffedUpdate()
					end
					UIDropDownMenu_AddButton(info, level)
				end
			end
			if (ActiveButton:GetName() == "BuffedMaster1") then
				info.text = "Check IsMine"
				info.value = 3
				info.checked =  BuffedSettings.IsMine
				info.tooltipTitle = "Check IsMine"
				info.tooltipText = "Only show the target buffs/debuffs that are yours."
				info.func = function()  
								if BuffedSettings.IsMine then
									BuffedSettings.IsMine = false
								else
									BuffedSettings.IsMine = true
								end	
								BuffedUpdate()
							end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "combat position save"
				info.value = 3
				info.checked =  nil
				info.tooltipTitle = "Save Combat Positions"
				info.tooltipText = "Save the current buff position as the location for buffs in combat"
				info.func = function()  
								for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
									for i = 1, FrameNum do 
										local f = _G["Buffed"..FrameName..i]
											if not BuffedProfiles[UnitName("player")] then
												BuffedProfiles[UnitName("player")] = {combat = {}, nocombat = {}}
											end
											local point, relativeTo, relativePoint, xofs, yofs = f:GetPoint()
											local width, height = floor(f:GetWidth() + 0.5), floor(f:GetHeight() + 0.5)
											BuffedProfiles[UnitName("player")].combat["Buffed"..FrameName..i] = {width = width, height = height, point = point, relativePoint = relativePoint, xofs = floor(xofs*100+0.5)/100, yofs = floor(yofs*100+0.5)/100}
											--print(f:GetName())
									end
								end
							end
				UIDropDownMenu_AddButton(info, level)
				
				info.text = "Save Positions"
				info.value = 3
				info.checked =  nil
				info.tooltipTitle = "Save the current position of all buffs"
				info.tooltipText = "Save the current buff position as the location for buffs out of combat"
				info.func = function()  
								for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
									for i = 1, FrameNum do 
										local f = _G["Buffed"..FrameName..i]
											if not BuffedProfiles[UnitName("player")] then
												BuffedProfiles[UnitName("player")] = {combat = {}, nocombat = {}}
											end
											local point, relativeTo, relativePoint, xofs, yofs = f:GetPoint()
											local width, height = floor(f:GetWidth() + 0.5), floor(f:GetHeight() + 0.5)
											BuffedProfiles[UnitName("player")].nocombat["Buffed"..FrameName..i] = {width = width, height = height, point = point, relativePoint = relativePoint, xofs = floor(xofs*100+0.5)/100, yofs = floor(yofs*100+0.5)/100}
									end
								end
							end
				UIDropDownMenu_AddButton(info, level)
			end
	end
end

UIDropDownMenu_Initialize(DropDownTest, DropDownTest_Initialize, "MENU")




--------------------------------- anchor buffs ---------------------------------

local function BuffedBuffButtonAnchors(buttonName, index, IsMine, buffname) 
	local buff = _G[buttonName..index]
	local confbuff = _G["BuffedBuff"..(index-HiddenCount)]
	--[[for i = 1, #BuffedSorter do
		if (BuffedSorter[i].number == (index-HiddenCount)) then
			confbuff = _G["BuffedBuff"..(i-HiddenCount)]
		end
	end]]
	if (buttonName == "TargetBuffedButton") then
		if BuffedSettings.IsMine and not IsMine then
			buff:Hide()
			HiddenCount = HiddenCount + 1
			return
		else
			confbuff = _G["BuffedTargetBuff"..index-HiddenCount]
		end
	end
	for i = 1, 20 do
	local f = _G["BuffedFilter"..i]
		if f and (f.name == buffname) then
			if BuffedProfiles.FilterFrames[buttonName]["BuffedFilter"..i] then
				if (BuffedProfiles.FilterFrames[buttonName]["BuffedFilter"..i].name == buffname) then
					confbuff = f
					HiddenCount = HiddenCount + 1
				end
			end
		end
	end
	if not confbuff then
		print("Something has gone very wrong, sorry")
		return
	end
	
	buff:ClearAllPoints()
	if BuffedSettings.animation then
		BuffedProfiles[buff:GetName()] = confbuff:GetName()
	else
		buff:SetAllPoints(confbuff)
	end
	for i = 1,2 do -- weapon enchant placement
		local buff = _G["TempEnchant"..i]
		local confbuff = _G["BuffedWep"..i]
		if buff then
			local point, relativeTo, relativePoint, xOfs, yOfs = confbuff:GetPoint()
			buff:ClearAllPoints()
			buff:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs)
		end
	end
end


--------------------------   Anchor debuffs ----------------
local function BuffedDebuffButtonAnchors(buttonName, index, IsMine, buffname)
	local buff = _G[buttonName..index]
	local confbuff = _G["BuffedDebuff"..(index-HiddenCount)]
	if (buttonName == "TargetDebuffedButton") then
		if BuffedSettings.IsMine and not IsMine then
			buff:Hide()
			HiddenCount = HiddenCount + 1
			return
		else
			confbuff = _G["BuffedTargetDebuff"..index-HiddenCount]
		end
	end
	for i = 1, 20 do
	local f = _G["BuffedFilter"..i]
		if f and (f.name == buffname) then
			if BuffedProfiles.FilterFrames[buttonName]["BuffedFilter"..i] then
				if (BuffedProfiles.FilterFrames[buttonName]["BuffedFilter"..i].name == buffname) then
					confbuff = f
					HiddenCount = HiddenCount + 1
				end
			end
		end
	end
	if not confbuff then
		print("Something has gone very wrong, sorry")
		return
	end
	
	buff:ClearAllPoints()
	if BuffedSettings.animation then
		BuffedProfiles[buff:GetName()] = confbuff:GetName()
	else
		buff:SetAllPoints(confbuff)
	end
end

SLASH_Buffed1 = "/buffed";
SlashCmdList["Buffed"] = ToggleLock;



local function BuffedTimeFormat(self, timer) -- format the time
local hours = floor(timer/3600)
local minutes = floor((timer-hours*3600)/60)
local seconds = floor((timer-hours*3600 -minutes*60))
	if self.verbose then
		if hours > 0 and minutes > 0 then
			return hours..":"..minutes
		elseif minutes > 0 then
			if seconds > 10 then 
				return minutes..": moo"..seconds
			else
				return minutes..": 0"..seconds
			end
		else
			return seconds
		end
	else
		if hours > 0 and minutes > 0 then
			if minutes >= 10 then 
				return hours..":"..minutes
			else
				return hours..":0"..minutes
			end
		elseif minutes > 0 then
			if minutes > 10 then
				return minutes.."m"
			else
				if seconds >= 10 then 
					return minutes..":"..seconds
				else
					return minutes..":0"..seconds
				end
			end
		else
			return seconds
		end
	end
end

local function BuffedButtonUpdateDuration(self, timeLeft)
	local duration = _G[self:GetName().."Duration"]
	if timeLeft then
		duration:SetFormattedText(BuffedTimeFormat(self, timeLeft));
		--print(timeLeft)
		if ( timeLeft < BUFF_DURATION_WARNING_TIME ) then
			duration:SetVertexColor(1, 1, 1);
		else
			duration:SetVertexColor(1, 1, 1);
		end
		duration:Show();
	else
		duration:Hide();
	end
end

local function BuffedButtonOnUpdate(self, elapsed, unit)
	local index = self:GetID();
	BuffedButtonUpdateDuration(self, self.timeLeft);
	self.timeLeft = max(self.timeLeft - elapsed, 0);
	local f = select(2, self:GetPoint())
	if f and not f.alpha then -- just in case it isnt parented to the config frames
		self:SetAlpha(math.max(0.3,(1 - (self.timeLeft-60)/777)))
	end
	if IsShiftKeyDown() then
		self:SetAlpha(1)
	end
	if ( GameTooltip:IsOwned(self) ) then
		GameTooltip:SetUnitAura(unit, index, self.filter);
	end
end

local function BuffedRightClick(self, button, Bname, buttonName)
	if ( button == "RightButton" ) then		
		CancelUnitBuff(self.unit, self:GetID(), self.filter)
	elseif ( button == "LeftButton" ) then
		if IsShiftKeyDown() then 
			if not BuffedProfiles.FilterFrames[buttonName][Bname] then
				for i = 1, 16 do
					frame = _G["BuffedFilter"..i]
					if frame and not frame.name then
						print("Added "..Bname.." to filter frames")
						BuffedProfiles.FilterFrames[buttonName]["BuffedFilter"..i] = {name = Bname, enabled = true, Ftype = buttonName, text = Bname}
						frame.enabled = true
						frame.name = Bname
						frame.Ftype = buttonName
						frame.fs:SetText(Bname)
						BuffedUpdate()
						return
					end
				end
			end 
		end
	end
end


local function BuffedButtonUpdate(buttonName, index, filter, unit)
	for i = index+1, 32 do -- hide any excess buffs that may have been created before the number shown was changed
		local buffName = buttonName..i;
		local buff = _G[buffName]
		if buff then
			buff:Hide()
		end
	end
	
	local name, rank, texture, count, debuffType, duration, expirationTime, IsMine = UnitAura(unit, index, filter);
	local buffName = buttonName..index;
	local buff = _G[buffName]
	local buffDuration = _G[buffName.."Duration"]
	
	
	if not name then
		-- No buff so hide it if it exists
		if buff then
			buff:Hide();
			buffDuration:Hide();
		end
		return nil;
	else
		local helpful = (filter == "HELPFUL");
		if not buff then -- If button doesn't exist make it
			local frametype
				if helpful then
					frametype = "BuffButtonTemplate"
				else
					frametype = "DebuffButtonTemplate"
				end
			buff = CreateFrame("Button", buffName, UIParent, frametype);
			buff:SetScript("OnUpdate", nil);
			buff:SetScript("OnEvent", nil);
			buff:SetScript("OnEnter", nil)
			buff:SetScript("OnShow", nil)
			buff:SetScript("OnClick", nil)
			buff:SetScript("OnMouseUp", function(self, button)  BuffedRightClick(self, button, name) end)
			buff:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
			GameTooltip:SetUnitAura(unit, self:GetID(), self.filter); end)
			buffDuration = _G[buffName.."Duration"]
		end
		-- Setup Buff
		buff.namePrefix = buttonName;
		buff:SetID(index);
		buff.unit = unit;
		buff.filter = filter;
		buff:SetAlpha(1.0);
		buff:Show();
		buff:SetScript("OnMouseUp", function(self, button)  BuffedRightClick(self, button, name, buttonName) end)
			
		-- Set filter-specific attributes
		if ( helpful ) then
			-- Anchor Buffs
			BuffedBuffButtonAnchors(buttonName, index, IsMine, name);
		else
			-- Anchor Debuffs
			BuffedDebuffButtonAnchors(buttonName, index, IsMine, name);

			-- Set color of debuff border based on dispel class.
			local debuffSlot = _G[buffName.."Border"]
			if ( debuffSlot ) then
				local color;
				if ( debuffType ) then
					color = DebuffTypeColor[debuffType];
				else
					color = DebuffTypeColor["none"];
				end
				debuffSlot:SetVertexColor(color.r, color.g, color.b);
			end
		end

		if ( duration > 0 and expirationTime ) then
			buffDuration:Show();
			if not buff.timeLeft then
				buff.timeLeft = expirationTime - GetTime();
				buff:SetScript("OnUpdate", function(self, elapsed) BuffedButtonOnUpdate(self, elapsed, unit) end);
			else
				buff.timeLeft = expirationTime - GetTime();
			end
		else
			buff:SetAlpha(0.5)
			buffDuration:Hide();
			if ( buff.timeLeft ) then
				buff:SetScript("OnUpdate", nil);
			end
			buff.timeLeft = nil;
		end
		
		local icon = _G[buffName.."Icon"] -- texture
		icon:SetTexture(texture);

		local buffCount = _G[buffName.."Count"] -- stacks
		if ( count > 1 ) then
			buffCount:SetText(count);
			buffCount:Show();
		else
			buffCount:Hide();
		end
		
		if ( GameTooltip:IsOwned(buff) ) then -- Refresh tooltip
			GameTooltip:SetUnitAura(unit, index, filter);
		end
	end
	return 1;
end

local function BuffedSort()
	wipe(BuffedSorter)
	if BuffedSettings.duration then
		for i = 1,BuffedSettings.FrameCreation.Buff do
		local name, rank, texture, count, debuffType, duration, expirationTime, IsMine = UnitAura("player", i, "HELPFUL");
			if (expirationTime == 0 ) or (expirationTime == nil ) then
				expirationTime =  GetTime() + 100000 + i
			end
			BuffedSorter[i] = {expTime = expirationTime, number = i }
		
		end
		if next(BuffedSorter) then
			table.sort(BuffedSorter, function (a,b) return a.expTime < b.expTime end)
		end
	end
end

function BuffedUpdate(self, event, ...)
	HiddenCount = 0 -- reset each time
	BuffedSort()
	for i=1, BuffedSettings.FrameCreation.Buff do
		BuffedButtonUpdate("BuffedBuffButton", i, "HELPFUL", "player")
	end
	HiddenCount = 0
	for i=1, BuffedSettings.FrameCreation.Debuff do
		BuffedButtonUpdate("BuffedDebuffButton", i, "HARMFUL", "player")
	end
	HiddenCount = 0
	for i=1, BuffedSettings.FrameCreation.TargetBuff do
		BuffedButtonUpdate("TargetBuffedButton", i, "HELPFUL", "target")
	end
	HiddenCount = 0
	for i=1, BuffedSettings.FrameCreation.TargetDebuff do
		BuffedButtonUpdate("TargetDebuffedButton", i, "HARMFUL", "target")
	end
	
end

local h = CreateFrame("Frame")
h:RegisterEvent("UNIT_AURA")
h:RegisterEvent("PLAYER_TARGET_CHANGED")
h:SetScript("OnEvent", BuffedUpdate)


local function BuffedPositioning(self, event, ...)
	if (event == "PLAYER_REGEN_ENABLED") then
		for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
			for i = 1, FrameNum do 
				local f = _G["Buffed"..FrameName..i]
				if f then
					if BuffedProfiles[UnitName("player")] and BuffedProfiles[UnitName("player")].nocombat and BuffedProfiles[UnitName("player")].nocombat["Buffed"..FrameName..i] then
						local pos = BuffedProfiles[UnitName("player")].nocombat["Buffed"..FrameName..i]
						f:SetPoint(pos.point, UIParent, pos.relativePoint, pos.xofs, pos.yofs)
						f:SetWidth(pos.width)
						f:SetHeight(pos.height)
					end
				end
			end
		end
		BuffedUpdate()
	elseif (event == "PLAYER_REGEN_DISABLED") then
		for FrameName, FrameNum in pairs(BuffedSettings.FrameCreation) do
			for i = 1, 32 do 
				local f = _G["Buffed"..FrameName..i]
				if BuffedProfiles[UnitName("player")] and BuffedProfiles[UnitName("player")].combat and BuffedProfiles[UnitName("player")].combat["Buffed"..FrameName..i] then
					local pos = BuffedProfiles[UnitName("player")].combat["Buffed"..FrameName..i]
					f:SetPoint(pos.point, UIParent, pos.relativePoint, pos.xofs, pos.yofs)
					f:SetWidth(pos.width)
					f:SetHeight(pos.height)
				end
			end
		end
		BuffedUpdate()
	end
end

local g = CreateFrame("Frame")
g:RegisterEvent("PLAYER_REGEN_ENABLED")
g:RegisterEvent("PLAYER_REGEN_DISABLED")
g:SetScript("OnEvent", BuffedPositioning)

function BuffFrame_Update()
end
function TargetFrame_UpdateAuras (self)
end
